
                TITLE Why startup code (d32f)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;  Why startup code for DOS 32-bit, flat memory model (d32f).
;;  Written by Y [08-05-00], based on old code by Y [11-08-99] and
;;    Tran's PMC startup code c0pmc.asm.
;;
;;  Copyright (c) 1999-2000 CROWELL, Inc. All Rights Reserved.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PUBLIC _cstart_, RTLError, _XStacks, _AtoR, _RtoA, _Extract
PUBLIC _NDup, _NDrop, _NSwap, _NExtract
PUBLIC _PutChar, _Put, _Cr, _NewLine
PUBLIC _GetChar, _Gets
PUBLIC _Malloc, _Realloc, _Free
PUBLIC _Random16, _Random32
EXTRN _Main: NEAR

                .386p
                .MODEL FLAT
                INCLUDE WHYEQU32.INC

_DATA           SEGMENT USE32 DWORD PUBLIC 'DATA'
_DATA           ENDS
_BSS            SEGMENT PARA PUBLIC USE32  'BSS'
_BSS            ENDS
_TEXT           SEGMENT USE32 DWORD PUBLIC 'CODE'
_TEXT           ENDS

DGROUP          GROUP _DATA, _BSS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

_DATA           SEGMENT DWORD PUBLIC USE32 'DATA'
                ORG 0

NULL            DD 0                    ; NULL address

_codebase       DD 0                    ; linear base of 32bit code segment
_database       DD 0                    ; linear base of 32bit data segment
_lowbase        DD 0                    ; idem

_pspbase        DD 0                    ; linear base of PSP
_envbase        DD 0                    ; linear base of environment
_codesel        DW 0, 0                 ; 32bit code selector
_datasel        DW 0, 0                 ; 32bit data selector
_pspsel         DW 0, 0                 ; PSP selector
_envsel         DW 0, 0                 ; environment selector
_zerosel        DW 0, 0                 ; zero base selector
__TEXTseg       DW _TEXT, 0
__DATAseg       DW _DATA, 0
__BSSseg        DW _BSS, 0
_pspseg         DW 0, 0
_envseg         DW 0, 0
_zeroptr        DD 0                    ; realative ptr to 0
_data_code      DD 0                    ; _codebase - _database
_code_data      DD 0                    ; _database - _codebase

_DPMIversion    LABEL WORD              ; full DPMI version
_DPMIminor      DB 0                    ; minor version of DPMI
_DPMImajor      DB 0                    ; major version of DPMI
                DW 0                    ; alignment

_rmstate        DD 0                    ; real mode state save seg:off
_rmswitch       DD 0                    ; real mode mode switch seg:off
_pmstate        DF 0                    ; protected mode state save sel:off
_pmswitch       DF 0                    ; protected mode mode switch sel:off
_statesize      DW 0, 0                 ; size of state buffer

_selinc         DW 0, 0                 ; selector increment value
_CPL            DB 0, 0,0,0             ; task CPL
_PMtype         DB 0, 0,0,0             ; protected mode type (from PMODE)
_processor      DB 0, 0,0,0             ; processor type
_PICtable       LABEL BYTE
_PICmaster      DB 0                    ; base interrupt of master PIC
_PICslave       DB 0                    ; base interrupt of slave PIC
                DB 0,0                  ; for alignment

_lowheapblock   DD 0,0,0                ; low memory heap info block
_extheapblock   DD 0,0,0                ; extended memory heap info block

_GDTR           LABEL PWORD
_gdtlimit       DW 0                    ; GDT limit and base
_gdtbase        DD 0

_rs             LABEL DWORD             ; register data structure
                DB 32h dup(0)

; annoying copyright banner ;)
DB 13, 10
DB 'Why not a compiler? by Y [06-04-00] or later. ', 13, 10
DB 'Copyright (c) 1999-2000 CROWELL, Inc. All Rights Reserved.', 13, 10, 0

_DATA           ENDS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.CODE

WhyNotToStart?:

_cstart_:       JMP     SHORT SkipBanner

; 'WATCOM' string for DOS4GW extender
DB 'WATCOM is not associated with CROWELL, Inc. in any way.', 13, 10, 0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Entry To ASM Code (_main)
;; In:
;;   CS - Code Selector    Base: 00000000h - Limit: 4G
;;   DS - Data Selector    Base: 00000000h - Limit: 4G
;;   ES - PSP Selector     Base: PSP Seg   - Limit: 100h
;;   FS - ?
;;   GS - ?
;;   SS - Data Selector    Base: 00000000h - Limit: 4G
;;   ESP -> STACK segment
;;   Direction Flag - ?
;;   Interrupt Flag - ?
;;
;;   All Other Registers Are Undefined!
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

EXTRN MB_INFO: NEAR, MB_ALLOC: NEAR, MBINIT: NEAR       ; externals from PMC
EXTRN L_MALLOC: NEAR, L_REALLOC: NEAR, L_FREE: NEAR

SkipBanner:     STI
                CLD

                ; init variables for PMC library
                MOV     _datasel, DS    ; data and code selectors
                MOV     _codesel, CS

                XOR     EDX, EDX
                MOV     _database, EDX
                MOV     _lowbase, EDX
                MOV     _codebase, EDX
                MOV     _code_data, EDX ; _database - _codebase
                MOV     _data_code, EDX ; _codebase - _database
                MOV     _zeroptr, EDX

                ; some code copied from c0pmc.asm by Tran
                MOV     BX, ES:[2Ch]    ; get environment selector
                MOV     _envsel, BX
                MOV     AX, 6
                INT     31h
                MOV     word ptr _envbase[0], DX
                MOV     word ptr _envbase[2], CX
                SHRD    DX, CX, 4
                MOV     _envseg, DX

                MOV     BX, ES          ; get PSP selector
                MOV     _pspsel, BX
                MOV     AX, 6           ; get segment base address
                INT     31h
                MOV     word ptr _pspbase[0], DX
                MOV     word ptr _pspbase[2], CX
                SHRD    DX, CX, 4
                MOV     _pspseg, DX

                MOV     AX, CS
                LAR     AX, AX
                SHR     AH, 5
                AND     AH, 3
                MOV     _CPL, AH
                MOV     AX, 3
                INT     31h
                MOV     _selinc, AX
                SHLD    EAX, EBP, 8
                MOV     _PMtype, AL
                MOV     AX, 400h
                INT     31h
                MOV     _DPMIversion, AX
                MOV     _processor, CL
                MOV     _PICmaster, DH
                MOV     _PICslave, DL

                MOV     AX, 305h
                INT     31h
                MOV     _statesize, AX
                MOV     word ptr _rmstate[0], CX
                MOV     word ptr _rmstate[2], BX
                MOV     dword ptr _pmstate[0], EDI
                MOV     word ptr _pmstate[4], SI
                MOV     AX, 306h
                INT     31h
                MOV     word ptr _rmswitch[0], CX
                MOV     word ptr _rmswitch[2], BX
                MOV     dword ptr _pmswitch[0], EDI
                MOV     word ptr _pmswitch[4], SI

                ; initialize low memory heap block
                MOV     AX, 0100h               ; allocate DOS memory block
                XOR     BX, BX                  ; set BX = 0xFFFF so the
                DEC     BX                      ;  call will fail
                INT     31h                     ; now BX = largest available
                MOVZX   EBX, BX
                MOV     AX, 0100h               ;  low memory block
                INT     31h                     ; now AX = real mode segment
                JC      @@CannotAllocateLow     ;  and DX = pmode selector

                MOVZX   EAX, AX                 ; calculate block base adx
                SHL     EAX, 4                  ;  using real mode segment

                MOV     _lowheapblock[0], EAX   ; set block base adx
                SHL     EBX, 4                  ; convert para to bytes
                MOV     _lowheapblock[4], EBX   ; set block size
                PUSH    offset DGROUP: _lowheapblock
                CALL    MBINIT                  ; initialize memory block
                JMP     @@LowHeapInitialized

   @@CannotAllocateLow:                         ; low memory allocation failed
                MOV     _lowheapblock[0], 0     ; base address of lowmem block
                MOV     _lowheapblock[4], 0
   @@LowHeapInitialized:

                ; initialize extended memory heap block
                PUSH    DS
                POP     ES                      ; set ES to DS
                CALL    MB_INFO                 ; EAX = free extended memory

                SUB     EAX, 10000h             ; decrease size for safety ;)
                PUSH    offset DGROUP: _extheapblock
                PUSH    EAX                     ; block size
                CALL    MB_ALLOC

                PUSH    offset DGROUP: _extheapblock
                CALL    MBINIT                  ; initialize ext. heap block

                ; set up zero selector
                MOV     CX, 1                   ; Number of descriptors
                XOR     AX, AX                  ; Allocate descriptor
                INT     31h

                MOV     BX, AX                  ; New descriptor
                MOV     CX, 0FFFFh
                MOV     DX, CX                  ; CX:DX = 4 gigabytes
                MOV     AX, 8                   ; Set segment limit
                INT     31h

                XOR     DX, DX                  ; zero-based
                XOR     CX, CX
                MOV     AX, 7                   ; Set segment base
                INT     31h

                MOV     _zerosel, BX            ; store zero selector

                ; set up _gdtbase and _gdtlimit
                SGDT    fword ptr _GDTR

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  Why-specific code follows
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                ; set up arithmetic stack (EBP)

                MOV     EBP, ESP
                SUB     EBP, 65536              ; 64K for rstack - ALWAYS
                                                ; and the rest for astack

                ; run Why code
                CALL    _Main

                MOV     AH,4Ch                  ; AH=4Ch - Exit To DOS
                INT     21h                     ; DOS INT 21h

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; RTLError - default error handler. Warning: never returns.
RTLError        PROC

                PUSH    EAX
                CALL    __GETDS         ; set up DS for safety
                LEA     EDX, ErrMsg
                MOV     AH, 9
                INT     21h             ; Display: "Error: "...
                POP     EAX

                CMP     EAX, erRtlLastError
                JB      RTLErrorOk
                XOR     EAX, EAX
   RTLErrorOk:
                LEA     EBX, ErrTable
                SHL     EAX, 2
                ADD     EBX, EAX
                MOV     EDX, [EBX]      ; Get error message address

                MOV     AH, 9
                INT     21h             ; Display error msg

                MOV     AX, 4CFFh
                INT     21h             ; Abort the program - quit to DOS

.DATA
ErrMsg          DB      serRtlRunTimeError
ErrMsg0         DB      serRtlUnknownError
ErrMsg1         DB      serRtlMemoryError
ErrMsg2         DB      serRtlBadDosVersion
ErrTable        DD      ErrMsg0, ErrMsg1, ErrMsg2
.CODE

                ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Random16 - generates 16-bit random number
; X -> Random16 between 0 and X-1
_Random16       PROC
                PUSH    ESI

                MOV     AX, [DS:Seed1]  ; why do I have to put DS: prefix
                MOV     CL, AL          ; everywhere?? why it is not assumed?
                MOV     BX, 117
                SUB     BX, [DS:Seed3]
                MUL     BX
                SUB     AX, 1000
                ROL     AX, CL
                ROR     AH, CL
                MOV     [DS:Seed1], AX
                ADD     AX, [DS:Seed2]
                MOV     [DS:Seed2], AX
                ADD     AX, [DS:Seed3]
                MOV     [DS:Seed3], AX

                MOV     BX, [DS:Seed4]
                INC     BX
                MOV     [DS:Seed4], BX
                CMP     BX, 31425
                JBE     @Fin

@Scramble:      MOV     [DS:Seed4], 0   ; {after 31425 iterations}
                MOV     AX, [DS:Seed3]  ; {we scramble all seeds}
                ADD     AX, CX          ; {to reach the better}
                MOV     BX, [DS:Seed2]  ; {randomization rate}
                SUB     BX, AX
                MOV     [DS:Seed2], AX
                MOV     AX, [DS:Seed1]
                MOV     [DS:Seed1], BX
                INC     AX
                MOV     [DS:Seed3], AX
@Fin:
                MOV     EBX, [EBP]      ; {put the result into the}
                MUL     BX              ; {interval between 0 and X}
                XOR     EAX, EAX
                MOV     AX, DX
                MOV     [EBP], EAX

                POP     ESI
                RET
_Random16       ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Random32 - generates 32-bit random number
; X -> Random32 between 0 and X-1
_Random32       PROC NEAR
                PUSH    ESI

                SUB     EBP, 4
                MOV     [EBP], dword ptr -1
                CALL    _Random16
                PUSH    dword ptr [EBP]
                MOV     [EBP], dword ptr -1
                CALL    _Random16
                MOV     EAX, [EBP]
                ADD     EBP, 4

                SHL     EAX, 16
                POP     EDX
                MOV     AX, DX          ; EAX = 32bit number (0..4G)

                MOV     EBX, [EBP]
                MUL     EBX
                MOV     EAX, EDX        ; EAX = random between 0 and X
                MOV     [EBP], EAX

                POP     ESI
                RET
_Random32       ENDP

.DATA
Seed1           DW 1,0                  ; random seeds
Seed2           DW 17,0
Seed3           DW 997,0
Seed4           DW 0,0
.CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; AtoR - puts astack top element to rstack
; a ->
_AtoR           PROC
                POP     EBX                     ; get return address
                MOV     EAX, [EBP]              ; get astack top element
                ADD     EBP, 4
                PUSH    EAX                     ; push rstack
                PUSH    EBX                     ; restore return address
                RET
                ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; RtoA - puts rstack top element to astack
; -> a
_RtoA           PROC
                POP     EBX                     ; get return address
                POP     EAX                     ; get rstack top element
                SUB     EBP, 4
                MOV     [EBP], EAX              ; push to astack
                PUSH    EBX                     ; restore return address
                RET
                ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Extract - extracts an element to the top
; am .. a2 a1 m -> am .. a2 a1 am
_Extract        PROC

                PUSH    ESI

                MOV     ECX, [EBP]              ; get index
                MOV     ESI, ECX
                SHL     ESI, 2
                MOV     AX, [EBP + ESI]
                MOV     [EBP], EAX

                POP     ESI
                RET
                ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; NExtract - extracts m elements to the top
; am .. a2 a1 m n -> am .. a2 a1 am .. am - n
_NExtract       PROC

                PUSH    ESI

                MOV     ECX, [EBP]              ; get counter
                MOV     EAX, [EBP + 4]          ; get index
                ADD     EBP, 8

                MOV     ESI, EAX
                DEC     ESI
                SHL     ESI, 2
  _NExtractLoop:
                MOV     EAX, [EBP + ESI]
                SUB     EBP, 4
                MOV     [EBP], EAX
                LOOPD   _NExtractLoop

                POP     ESI
                RET
                ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; NDup - duplicates n top stack elements
; a1 a2 ... an n -> a1 a2 .. an a1 a2 .. an
_NDup           PROC

                PUSH    ESI

                MOV     ECX, [EBP]              ; get counter
                ADD     EBP, 4

                MOV     ESI, ECX
                DEC     ESI
                SHL     ESI, 2
  _NDupLoop:
                MOV     EAX, [EBP + ESI]
                SUB     EBP, 4
                MOV     [EBP], EAX
                LOOPD   _NDupLoop

                POP     ESI
                RET
                ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; NDrop - drops n elements
; a1 a2 .. an n ->
_NDrop          PROC

                MOV     ECX, [EBP]              ; get counter
                ADD     EBP, 4

                SHL     ECX, 2                  ; bytes to add
                ADD     EBP, ECX
                RET
                ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; NSwap - swaps two sequences of any length
; a1 a2 .. an b1 b2 .. bn n -> b1 b2 .. bn a1 a2 .. an
_NSwap          PROC

                PUSH    ESI

                MOV     ECX, [EBP]              ; get counter
                ADD     EBP, 4

                MOV     ESI, ECX
                SHL     ESI, 2

                MOV     EBX, EBP
  _NSwapLoop:
                MOV     EAX, [EBP]
                XCHG    EAX, [EBP + ESI]
                MOV     [EBP], EAX
                ADD     EBP, 4
                LOOPD   _NSwapLoop
                MOV     EBP, EBX

                POP     ESI
                RET
                ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; XStacks - exchanges astack and rstack
; ->
_XStacks        PROC
                POP     EAX             ; get retn address
                XCHG    ESP, EBP
                PUSH    EAX             ; restore retn address

                RET
                ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Malloc - allocates memory
; Size -> Ptr
_Malloc         PROC
                PUSH    ESI

                PUSH    dword ptr [EBP]         ; Size
                CALL    L_MALLOC
                MOV     [EBP], EAX

                POP     ESI
                RET
                ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Realloc - resizes memory block
; Ptr NewSize -> Ptr
_Realloc        PROC
                PUSH    ESI

                PUSH    dword ptr [EBP + 4]     ; Ptr
                PUSH    dword ptr [EBP]         ; NewSize
                CALL    L_REALLOC
                MOV     [EBP + 4], EAX

                ADD     EBP, 4
                POP     ESI
                RET
                ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Free - frees memory block
; Ptr ->
_Free           PROC
                PUSH    ESI

                PUSH    dword ptr [EBP]
                ADD     EBP, 4
                CALL    L_FREE

                POP     ESI
                RET
                ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; PutChar - prints single character to stdout
_PutChar        PROC

                MOV     EAX, [EBP]
                ADD     EBP, 4
                MOV     _PutCharData, AL
                LEA     EDX, _PutCharData
                MOV     ECX, 1
                MOV     BX, hRtlStdout
                MOV     AH, 40h
                INT     21h             ; Write data to stdout
                RET
.DATA
_PutCharData    DB      10
.CODE
                ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Put - prints ASCIIZ string to stdout without appending a CR/LF
; String ->
_Put            PROC

                PUSH    ESI

                MOV     ESI, [EBP]
                ADD     EBP, 4

                TEST    ESI, ESI        ; Is it null pointer?
                JZ      _PutNullPassed

                PUSH    ESI             ; Store string pointer
                XOR     ECX, ECX        ; String length counter
   _PutLoop:
                LODSB
                TEST    AL, AL
                JZ      _PutLoopEnd
                INC     ECX
                JMP     _PutLoop
   _PutNullPassed:
                LEA     EDX, _PutNullString
                MOV     ECX, 6
                JMP     _PutPut
   _PutLoopEnd:
                POP     EDX             ; Restore string pointer
                JCXZ    _PutEnd
   _PutPut:
                MOV     BX, hRtlStdout
                MOV     AH, 40h
                INT     21h             ; Write data to stdout
   _PutEnd:
                POP     ESI
                RET

.DATA
_PutNullString  DB      '(null)'
.CODE
                ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Cr (NewLine) - prints CR/LF to stdout
_NewLine        PROC

_Cr:            LEA     EDX, _NewLineCR
                MOV     ECX, 2
                MOV     BX, hRtlStdout
                MOV     AH, 40h
                INT     21h             ; Write data to stdout
                RET
.DATA
_NewLineCR      DB      13, 10
.CODE
                ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GetChar - reads single character from stdin
; -> Char
_GetChar        PROC
                PUSH    ESI

                SUB     EBP, 4
                LEA     EDX, _GetChar_Data
                MOV     AH, 03Fh
                MOV     BX, hRtlStdin
                MOV     ECX, 1
                INT     21h
                JC      _GetChar_Error
                XOR     EAX, EAX
                MOV     AL, _GetChar_Data
                MOV     [EBP], EAX
                JMP     _GetChar_End
_GetChar_Error: MOV     [EBP], dword ptr 0
_GetChar_End:
                POP     ESI
                RET
.DATA
_GetChar_Data DB 4 dup (0)
.CODE
                ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Gets - reads string from stdin into the buffer provided.
; Buffer must be have at least 130 bytes capacity
; Str ->
_Gets           PROC
                PUSH    ESI

                MOV     EDX, [EBP]
                MOV     AH, 03Fh
                MOV     BX, hRtlStdin
                MOV     ECX, 128
                INT     21h
                JC      _Gets_Error
                MOV     [EDX + EAX - 2], byte ptr 0     ; erase CR/LF
                JMP     _Gets_End
_Gets_Error:    ;MOV     [EBP], dword ptr 0
_Gets_End:
                ADD     EBP, 4
                POP     ESI
                RET
                ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; __GETDS - used in interrupt handlers
PUBLIC __GETDS
__GETDS         PROC NEAR
                MOV     AX, DGROUP
                MOV     DS, AX
                RETN
__GETDS         ENDP

_TEXT           ENDS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PUBLIC NULL, _codebase, _database, _lowbase, _pspbase, _envbase, _codesel
PUBLIC _datasel, _pspsel, _envsel, _zerosel, __TEXTseg, __DATAseg, __BSSseg
PUBLIC _pspseg, _envseg, _zeroptr, _data_code, _code_data, _DPMIversion
PUBLIC _DPMIminor, _DPMImajor, _rmstate, _rmswitch, _pmstate, _pmswitch
PUBLIC _statesize, _selinc, _CPL, _PMtype, _processor, _PICtable, _PICmaster
PUBLIC _PICslave, _lowheapblock, _extheapblock, _rs
PUBLIC _GDTR, _gdtbase, _gdtlimit

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; STACK
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

_STACK          SEGMENT PARA STACK 'STACK'
                ;DB 1000h dup(?)
                DB ?                    ; stack is set by wlink
_STACK          ENDS

                END     WhyNotToStart?

